diff --git a/hw/xquartz/xpr/xprScreen.c b/hw/xquartz/xpr/xprScreen.c
index 562d6a0c3..1dc23211c 100644
--- a/hw/xquartz/xpr/xprScreen.c
+++ b/hw/xquartz/xpr/xprScreen.c
@@ -33,6 +33,7 @@
 #include <dix-config.h>
 #endif
 
+#include "quartzCommon.h"
 #include "inputstr.h"
 #include "quartz.h"
 #include "quartzRandR.h"
@@ -55,6 +56,11 @@
 
 #include "nonsdk_extinit.h"
 
+#if MAC_OS_X_VERSION_MIN_REQUIRED < 1090
+// From NSApplication.h
+extern const double NSAppKitVersionNumber;
+#endif
+
 /* 10.4's deferred update makes X slower.. have to live with the tearing
  * for now.. */
 #define XP_NO_DEFERRED_UPDATES 8
@@ -166,13 +172,18 @@ displayScreenBounds(CGDirectDisplayID id)
               (int)frame.origin.x, (int)frame.origin.y);
 
     Boolean spacePerDisplay = false;
-    Boolean ok;
-    (void)CFPreferencesAppSynchronize(CFSTR("com.apple.spaces"));
-    spacePerDisplay = ! CFPreferencesGetAppBooleanValue(CFSTR("spans-displays"),
-                                                        CFSTR("com.apple.spaces"),
-                                                        &ok);
-    if (!ok)
-        spacePerDisplay = true;
+#if MAC_OS_X_VERSION_MIN_REQUIRED < 1090
+    if (NSAppKitVersionNumber >= 1265)
+#endif
+    {
+        Boolean ok;
+        (void)CFPreferencesAppSynchronize(CFSTR("com.apple.spaces"));
+        spacePerDisplay = ! CFPreferencesGetAppBooleanValue(CFSTR("spans-displays"),
+                                                            CFSTR("com.apple.spaces"),
+                                                            &ok);
+        if (!ok)
+            spacePerDisplay = true;
+    }
 
     /* Remove menubar to help standard X11 window managers.
      * On Mavericks and later, the menu bar is on all displays when spans-displays is false or unset.
@@ -322,6 +333,10 @@ xprAddScreen(int index, ScreenPtr pScreen)
     DEBUG_LOG("index=%d depth=%d\n", index, depth);
 
     if (depth == -1) {
+#if MAC_OS_X_VERSION_MIN_REQUIRED < 1060
+        depth = CGDisplaySamplesPerPixel(kCGDirectMainDisplay) *
+                CGDisplayBitsPerSample(kCGDirectMainDisplay);
+#else
         CGDisplayModeRef modeRef;
         CFStringRef encStrRef;
 
@@ -351,9 +366,12 @@ xprAddScreen(int index, ScreenPtr pScreen)
         }
 
         CFRelease(encStrRef);
+#endif
     }
 
+#if MAC_OS_X_VERSION_MIN_REQUIRED >= 1060
 have_depth:
+#endif
     switch (depth) {
     case 8:     // pseudo-working
         dfb->visuals = PseudoColorMask;
-- 
2.24.3 (Apple Git-128)

